SystemOrganization addCategory: #Campo!

TestCase subclass: #AnimalCerdoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!AnimalCerdoTest methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:52'!
test01DadoUnCerdoCuandoComeAumentaSuPesoMenos200
	|unCerdo|
	unCerdo := Cerdo new.
	unCerdo come: 0.199 .
	self assert: unCerdo peso equals:  20.
	unCerdo come: 0.5 .
	self assert: unCerdo peso equals: 20.5.
	unCerdo come: 1.5.
	self deny:( unCerdo tieneHambre).
	! !

!AnimalCerdoTest methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:54'!
test02DadoUnCerdoCuandoBebeSeLeVaLaSedYLeDaHambre
	|unCerdo|
	unCerdo := Cerdo new.
	unCerdo bebe.
	self deny: (unCerdo tieneSed).
	self assert: (unCerdo tieneHambre).
	
 ! !

!AnimalCerdoTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:50'!
test03DadoUnCerdoHayQueVacunarloSiempre
	|unCerdo|
	unCerdo := Cerdo new.
	
	self assert: (unCerdo convieneVacunarlo).
	
 ! !

!AnimalCerdoTest methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:56'!
test04DadoUnCerdoCuandoComeMasTresVecesSinBeberLeDaSed
	|unCerdo|
	unCerdo := Cerdo new.
	unCerdo bebe.
	unCerdo come:1.25.
	unCerdo come:4.2.
	unCerdo come:2.87.
	unCerdo come:2.87.
	self assert: (unCerdo tieneSed).

	
 ! !

!AnimalCerdoTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/2/2012 21:28'!
testUnCerdoComeVariasVeces
	|unCerdo|
	unCerdo := Cerdo new.
	unCerdo come: 0.199 .
	unCerdo come:0.25.
	unCerdo come:1.25.
	unCerdo come:4.2.
	unCerdo come:2.87.
	
	self assert: (unCerdo maximoComido = 4.2).
	
 ! !

TestCase subclass: #AnimalGallinaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!AnimalGallinaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/3/2012 20:03'!
test01DadaUnaGallinaCuandoComeNoSeObservaNingunCambio
	| unaGallina |
	unaGallina := Gallina new.
	unaGallina come:10.
	self assert:(unaGallina peso=4).	! !

!AnimalGallinaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:33'!
test02DadaUnaGallinaNuncaTieneSed
	| unaGallina |
	unaGallina := Gallina new.
	self deny:(unaGallina tieneSed).	! !

TestCase subclass: #AnimalVacaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!AnimalVacaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:33'!
test01DadaUnaVacaCuandoComeAumentaElPesoYLeDaSed
	| unaVaca pesovaca comida |
	comida := 30.
	unaVaca := Vaca new.
	pesovaca := unaVaca peso.
	unaVaca come: comida.
	self assert: unaVaca peso equals: pesovaca + (comida / 3).
	self assert: unaVaca tieneSed! !

!AnimalVacaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:33'!
test02DadaUnaVacaCuandoBebeSeLeVaLaSedYPierde500g

|unaVaca pesovaca |

unaVaca := Vaca new.
pesovaca:= unaVaca peso.
unaVaca bebe.
self assert: unaVaca peso equals: (pesovaca-0.5).
self deny: unaVaca tieneSed 

! !

!AnimalVacaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:50'!
test03DadaUnaVacaVacunadaNoVacunarla

|unaVaca |
unaVaca := Vaca new.
unaVaca esVacunado.
self assert: unaVaca vacunado.
self deny: unaVaca convieneVacunarlo


! !

!AnimalVacaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:50'!
test04DadaUnaVacaNoVacunadaHayQueVacunarla
	| unaVaca |
	unaVaca := Vaca new.
	
	self deny: unaVaca vacunado.
	self assert: unaVaca convieneVacunarlo! !

!AnimalVacaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:33'!
test05DadaUnaVacaTieneHambreSiPesaMenosDe200
	| unaVaca pesovaca|
	unaVaca := Vaca new.
	pesovaca := unaVaca peso.
	self assert: pesovaca <200.
	self assert: unaVaca tieneHambre.
	
	 ! !

!AnimalVacaTest methodsFor: 'as yet unclassified' stamp: 'RU 10/2/2012 22:03'!
test06DadaUnaVacaCuandoCaminaPierde3kg
	| unaVaca pesovaca|
	unaVaca := Vaca new.
	
	pesovaca := unaVaca peso.
	unaVaca camina.
	self assert: unaVaca peso equals: pesovaca-3.
	
	 ! !

TestCase subclass: #DispBebederoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!DispBebederoTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:37'!
test01DadoUnAnimalSinSedNoLeDaDeBeber
	|unaVaca unBebedero|
	unaVaca := Vaca new.
	unBebedero := Bebedero new.

	self deny: unaVaca tieneSed.
	self deny: (unBebedero puedeAtenderA: unaVaca).! !

!DispBebederoTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:41'!
test02DadoUnAnimalConSedLeDaDeBeber
	|unaVaca unBebedero|
	unaVaca := Vaca new.
	unBebedero := Bebedero new.

	self deny: unaVaca tieneSed.
	unaVaca come:30.
	self assert: unaVaca tieneSed.
	self assert: (unBebedero puedeAtenderA: unaVaca).! !

!DispBebederoTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:46'!
test03DadoUnComederoSiAtendioA20AnimalesDebeSerRecargado
	|unBebedero unaVaca |
	unBebedero:=Bebedero new. 
	unaVaca :=Vaca new.
	
	self deny: unBebedero debeSerRecargado.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	unBebedero atiendeA: unaVaca.
	self assert: unBebedero debeSerRecargado.
	

	! !

TestCase subclass: #DispComederoInteligenteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!DispComederoInteligenteTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:32'!
test01DadoUnAnimalSinHambreUnComederoInteligenteNoLeDaComida
	|unaVaca unComedero|
	unaVaca := Vaca new.
	unComedero := Inteligente new.

	unaVaca come:300.
	self deny: unaVaca tieneHambre.
	self deny: (unComedero puedeAtenderA:unaVaca).! !

!DispComederoInteligenteTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:32'!
test02DadoUnAnimalConHambreUnComederoInteligenteLeDaComida
	|unaVaca unComedero|
	 unaVaca := Vaca new.
	 unComedero := Inteligente new.

	self assert: unaVaca tieneHambre.
	self assert: (unComedero puedeAtenderA:unaVaca).! !

!DispComederoInteligenteTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:46'!
test03DadoUnaVacaQueComeDeUnComederoInteligenteComeUnCentesimoDeSuPeso
	|unaVaca unComedero unPeso|
 	unaVaca := Vaca new.
	unComedero := Inteligente new.
 
 	unPeso:= unaVaca peso.
	unComedero atiendeA:unaVaca.
 	self assert: unaVaca peso equals: unPeso+(unPeso/300)
  ! !

!DispComederoInteligenteTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:00'!
test04DadoUnComederoInteligenteSiTieneMenosDe15KgRecarga
 	|unComedero |
  	unComedero := Inteligente new.
	
	self assert: ((unComedero cuantaComidaTiene) < 15).
	self assert: (unComedero debeSerRecargado ).
	unComedero esRecargado. 
	self assert: unComedero cuantaComidaTiene equals: unComedero cualEsSuCapacidadMaxima.
  

  ! !

TestCase subclass: #DispComederoNormalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!DispComederoNormalTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:31'!
test01DadoUnAnimalSinHambreUnComederoNormalNoLeDaComida
	|unaVaca unComedero|
	unaVaca := Vaca new.
	unComedero := Normal new.

	unaVaca come:300.
	self deny: unaVaca tieneHambre.
	self deny: (unComedero puedeAtenderA:unaVaca).! !

!DispComederoNormalTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:31'!
test02DadoUnAnimalConHambreUnComederoNormalLeDaComida
	|unaVaca unComedero|
	 unaVaca := Vaca new.
	 unComedero := Inteligente new.

	self assert: unaVaca tieneHambre.
	self assert: (unComedero puedeAtenderA:unaVaca).
	! !

!DispComederoNormalTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:31'!
test03DadoUnAnimalConHambreQuePesaMasDeLoQueSoportaElComederoNormalEsteNoLeDaComida
	|unaVaca unComedero|
	 unaVaca := Vaca new.
	 unComedero := Inteligente new.
	
	self assert: unaVaca tieneHambre.
	unaVaca come: 3000.
	self deny: (unComedero puedeAtenderA:unaVaca).
	! !

!DispComederoNormalTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:46'!
test04DadoUnaVacaQueComeDeUnComederoNormalSeLeDaUnaRacionDeComida
	|unaVaca unComederoNormal unPeso|
 	unaVaca := Vaca new.
	unComederoNormal := Normal new.
 
 	unPeso:= unaVaca peso.
	unComederoNormal atiendeA:unaVaca.
 	self assert: (unaVaca peso) equals: (unPeso+((unComederoNormal cuantoValeUnaRacion)/3))
  ! !

!DispComederoNormalTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:00'!
test05DadoUnComederoNormalSiTieneMenosDe10RacionesSeLoRecarga
	|unComederoNormal racionesRestantes|
	unComederoNormal := Normal new.
 
	racionesRestantes:= unComederoNormal cuantasRacionesTiene.
	self assert: racionesRestantes<10.
	self assert: unComederoNormal debeSerRecargado.
	unComederoNormal esRecargado.
	self assert: racionesRestantes+(unComederoNormal cuantoValeUnaRacion) equals: unComederoNormal cuantasRacionesTiene..
	
 	
  ! !

TestCase subclass: #DispVacunatorioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!DispVacunatorioTest methodsFor: 'as yet unclassified' stamp: 'RU 10/6/2012 02:15'!
test01DadoUnAnimalQueConvieneVacunarElVacunatorioLoVacuna
	|unVacunatorio unAnimal|
	unVacunatorio:= Vacunatorio new.
	unAnimal:= Cerdo new.
	
	self assert: unAnimal convieneVacunarlo.
	self assert: (unVacunatorio puedeAtenderA: unAnimal).
	unVacunatorio atiendeA: unAnimal.
	
 	
  ! !

!DispVacunatorioTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:57'!
test02DadoUnAnimalQueNoConvieneVacunarElVacunatorioNoLoVacuna
	|unVacunatorio unAnimal|
	unVacunatorio:= Vacunatorio new.
	unAnimal:= Gallina new.
	
	self deny:  unAnimal convieneVacunarlo.
	self deny: (unVacunatorio puedeAtenderA: unAnimal)
 	! !

!DispVacunatorioTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:00'!
test03DadoUnVacunatorioSinVacunasNecesitaSerRecargado
	|unVacunatorio unAnimal|
	unVacunatorio:= Vacunatorio new.
	unAnimal:= Cerdo new.
		
	unVacunatorio atiendeA: unAnimal.
	unVacunatorio atiendeA: unAnimal.
	unVacunatorio atiendeA: unAnimal.
	unVacunatorio atiendeA: unAnimal.	
	unVacunatorio atiendeA: unAnimal.		
	self assert: unVacunatorio debeSerRecargado.
	unVacunatorio esRecargado.
	self assert: unVacunatorio cuantasVacunastiene equals: 50.
	
	
 	! !

TestCase subclass: #EstaciondeServicioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!EstaciondeServicioTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 23:18'!
test01DadoUnAnimalSaberSiPuedeSerAtendidoPorUnaEstacion
	|unAnimal unaEstacion |
	unAnimal:=Vaca new.
	unaEstacion:=EstaciondeServicio new.
	
	self assert: (unaEstacion puedeAtenderA: unAnimal).
	! !

!EstaciondeServicioTest methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 23:44'!
test02DadoUnAnimalQueNoPuedeSerAtendidoPorUnaEstacionNoAtenderlo
	|unAnimal unaEstacion |
	unAnimal:=Gallina new.
	unaEstacion:=EstaciondeServicio new.
	
	self deny: (unaEstacion puedeAtenderA: unAnimal).
	! !

!EstaciondeServicioTest methodsFor: 'as yet unclassified' stamp: 'RU 10/6/2012 02:07'!
test03DadaUnaEstacionSaberSiAlgunoDeSusDispositivosNecesitaSerRecargado
	|unaEstacion |
	unaEstacion:=EstaciondeServicio new.
	
	self assert: (unaEstacion tieneAlgunDispositivoQueDebaSerRecargado).
	unaEstacion recargarLosDispositivosQueLoRequieran.
	self deny: (unaEstacion tieneAlgunDispositivoQueDebaSerRecargado).
	
	
	
	
	! !

!EstaciondeServicioTest methodsFor: 'as yet unclassified' stamp: 'RU 10/6/2012 17:56'!
test04DadoUnAnimalQuePuedaSerAtendidoEnUnaEstacionSeEligeAlAzarUnDispositivoYSeLoAtiende
	|unaEstacion unAnimal|
	unaEstacion:=EstaciondeServicio new.
	unAnimal:= Vaca new.
	
	self assert: (unaEstacion puedeAtenderA: unAnimal).
	unaEstacion atiendeA: unAnimal.

	
	
	
	
	
	
	! !

Object subclass: #Animal
	instanceVariableNames: 'peso sed vacunado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Animal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:43'!
bebe! !

!Animal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 00:09'!
come:unaCantidad
	self subclassResponsibility.! !

!Animal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:50'!
convieneVacunarlo 
	self subclassResponsibility ! !

!Animal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:48'!
esVacunado
! !

!Animal methodsFor: 'as yet unclassified' stamp: 'RU 10/6/2012 17:40'!
initialize
	vacunado:=false.
	sed:=false.
! !

!Animal methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/2/2012 21:09'!
peso
	^peso.! !

!Animal methodsFor: 'as yet unclassified' stamp: 'RU 10/6/2012 17:44'!
tieneHambre
	^false! !

!Animal methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:33'!
tieneSed
	^sed.! !

!Animal methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/2/2012 21:48'!
vacunado
	^vacunado.! !

Animal subclass: #Cerdo
	instanceVariableNames: 'historialDeComida vecesQueComio hambre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Cerdo methodsFor: 'updating' stamp: 'MartnPerazzo 10/2/2012 21:57'!
bebe
	sed:=false.
	hambre:=true.
	vecesQueComio:=0.! !

!Cerdo methodsFor: 'updating' stamp: 'RU 10/3/2012 19:57'!
come: unPeso 
     vecesQueComio:=vecesQueComio +1.
     vecesQueComio >3
     ifTrue: [sed:=true].
     historialDeComida add: unPeso .
     unPeso>= 0.2
     ifTrue: [ peso:=peso + unPeso].
     unPeso> 1
     ifTrue: [hambre :=false ].
     
 ! !

!Cerdo methodsFor: 'updating' stamp: 'RU 10/5/2012 12:50'!
convieneVacunarlo 
	^true! !

!Cerdo methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/2/2012 21:45'!
historialOrdenadoDeComidas
	^ historialDeComida asSortedCollection: [ :peso1 :peso2 | peso1 > peso2 ]! !

!Cerdo methodsFor: 'as yet unclassified' stamp: 'RU 10/6/2012 17:40'!
initialize
	super initialize.
	hambre:=false.
	peso:=20.
	historialDeComida:= OrderedCollection   new.
	vecesQueComio:=0.
	! !

!Cerdo methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/2/2012 21:46'!
maximoComido
	^self historialOrdenadoDeComidas first.! !

!Cerdo methodsFor: 'evaluating' stamp: 'RU 10/6/2012 17:43'!
tieneHambre
	^hambre! !

Animal subclass: #Gallina
	instanceVariableNames: 'necesidades cantidadComidas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Gallina methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:49'!
come: unaCantidad
	cantidadComidas add: unaCantidad.! !

!Gallina methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:50'!
convieneVacunarlo 
	^false! !

!Gallina methodsFor: 'as yet unclassified' stamp: 'Guidito 10/2/2012 21:51'!
cuantoComio
	^cantidadComidas size.! !

!Gallina methodsFor: 'as yet unclassified' stamp: 'RU 10/3/2012 20:17'!
initialize
	super initialize.
	peso := 4.
	cantidadComidas := OrderedCollection new.! !

Animal subclass: #Vaca
	instanceVariableNames: 'prueba'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:41'!
bebe
	peso:= peso-0.5.
 	sed:=false
  ! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:41'!
camina
 	peso:= peso - 3.! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/3/2012 20:02'!
come: pesocomida
	peso:=peso+(pesocomida/3).
	sed:=true
	! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:50'!
convieneVacunarlo
	^(vacunado=false).! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:48'!
esVacunado
	vacunado:=true! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:41'!
initialize 
	super initialize.
	peso:= 101.
! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/3/2012 20:26'!
peso
	^peso.! !

!Vaca methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:33'!
tieneHambre
	^(peso<200)
! !

Object subclass: #Dispositivo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

Dispositivo subclass: #Bebedero
	instanceVariableNames: 'cantidadAnimalesAtendidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Bebedero methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:46'!
atiendeA: unAnimal 
	unAnimal bebe.
	cantidadAnimalesAtendidos:=cantidadAnimalesAtendidos+1! !

!Bebedero methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:58'!
debeSerRecargado 
	^(cantidadAnimalesAtendidos=20)! !

!Bebedero methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:00'!
esRecargado
	cantidadAnimalesAtendidos:=0! !

!Bebedero methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:57'!
initialize
	cantidadAnimalesAtendidos:=0! !

!Bebedero methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:36'!
puedeAtenderA: unAnimal
	^unAnimal tieneSed.
	! !

Dispositivo subclass: #Comedero
	instanceVariableNames: 'cantidadComida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Comedero methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:45'!
cuantaComidaTiene
	^cantidadComida ! !

!Comedero methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 00:02'!
entregaComida:comida
	cantidadComida:= cantidadComida-comida.! !

Comedero subclass: #Inteligente
	instanceVariableNames: 'capacidadMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Inteligente methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:46'!
atiendeA:unAnimal
	|comidaEntregada|
	comidaEntregada:=unAnimal peso/100.
	
	unAnimal come: (comidaEntregada).
	self entregaComida: (comidaEntregada)
 ! !

!Inteligente methodsFor: 'as yet unclassified' stamp: 'RU 10/4/2012 23:42'!
cualEsSuCapacidadMaxima
	^capacidadMax! !

!Inteligente methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:52'!
debeSerRecargado 
	^(cantidadComida <15)! !

!Inteligente methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:00'!
esRecargado
	cantidadComida := capacidadMax.! !

!Inteligente methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 00:37'!
initialize
	cantidadComida:=14.
	capacidadMax :=300.
! !

!Inteligente methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:33'!
puedeAtenderA: unAnimal
	^(unAnimal tieneHambre )! !

Comedero subclass: #Normal
	instanceVariableNames: 'racion pesoQueSoporta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Normal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:46'!
atiendeA: unAnimal
	unAnimal come: racion.
	self entregaComida: racion! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 01:07'!
cuantasRacionesTiene
	^(cantidadComida/racion)! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 00:42'!
cuantoValeUnaRacion
	^racion! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:53'!
debeSerRecargado 
	^(self cuantasRacionesTiene <10)! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:00'!
esRecargado 
	cantidadComida:=cantidadComida+(racion*30)
! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 00:57'!
initialize
	racion:= 30.
	cantidadComida:=racion*5.
	pesoQueSoporta:=300! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:32'!
puedeAtenderA: unAnimal
	^(unAnimal tieneHambre ) & (unAnimal peso < pesoQueSoporta)! !

!Dispositivo methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:46'!
atiendeA: unAnimal
	self subclassResponsibility ! !

!Dispositivo methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:49'!
debeSerRecargado
	self subclassResponsibility ! !

!Dispositivo methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:00'!
esRecargado
	self subclassResponsibility ! !

!Dispositivo methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 11:29'!
puedeAtenderA: unAnimal
	self subclassResponsibility! !

Dispositivo subclass: #Vacunatorio
	instanceVariableNames: 'cantidadVacunas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!Vacunatorio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:46'!
atiendeA: unAnimal
	unAnimal esVacunado.
	cantidadVacunas:=cantidadVacunas-1.! !

!Vacunatorio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:02'!
cuantasVacunastiene
	^cantidadVacunas! !

!Vacunatorio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:01'!
debeSerRecargado
	^(cantidadVacunas=0)! !

!Vacunatorio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 13:00'!
esRecargado
	cantidadVacunas:=50! !

!Vacunatorio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:10'!
initialize
	cantidadVacunas:=5! !

!Vacunatorio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 12:51'!
puedeAtenderA: unAnimal
	^unAnimal convieneVacunarlo.! !

Object subclass: #EstaciondeServicio
	instanceVariableNames: 'dispositivos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Campo'!

!EstaciondeServicio methodsFor: 'as yet unclassified' stamp: 'RU 10/6/2012 17:52'!
atiendeA: unAnimal
	|dispositivosQuePuedenAtender| 
	dispositivosQuePuedenAtender:= dispositivos select: [:each|each puedeAtenderA: unAnimal].
	dispositivosQuePuedenAtender:=dispositivosQuePuedenAtender atRandom.
	dispositivosQuePuedenAtender atiendeA: unAnimal
	
	! !

!EstaciondeServicio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 23:35'!
initialize 
	dispositivos:=OrderedCollection   new
        add:  Inteligente new; 
        add: Vacunatorio new; 
        add: Bebedero new; 
        yourself.! !

!EstaciondeServicio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 23:42'!
puedeAtenderA: unAnimal
	^(((dispositivos at: 1) puedeAtenderA: unAnimal)|((dispositivos at: 2) puedeAtenderA: unAnimal)|((dispositivos at: 3) puedeAtenderA: unAnimal)).! !

!EstaciondeServicio methodsFor: 'as yet unclassified' stamp: 'RU 10/6/2012 00:00'!
recargarLosDispositivosQueLoRequieran
	(dispositivos at: 1) debeSerRecargado 
		ifTrue: [(dispositivos at: 1) esRecargado ].
	(dispositivos at: 2) debeSerRecargado 
		ifTrue: [dispositivos at: 2 esRecargado ].
	(dispositivos at: 3) debeSerRecargado 
		ifTrue: [dispositivos at: 3 esRecargado ].			! !

!EstaciondeServicio methodsFor: 'as yet unclassified' stamp: 'RU 10/5/2012 23:51'!
tieneAlgunDispositivoQueDebaSerRecargado
	^(((dispositivos at: 1) debeSerRecargado )|((dispositivos at: 2) debeSerRecargado )|((dispositivos at: 3) debeSerRecargado )).! !
